local riseERR
local myID, myShipID
local ControlSlots, wtEngine, wtHull, wtShields, wtInsight, wtHVelocity, wtShortHP, wtShortHPtxt, wtShortEN, wtShortENtxt, wtName, wtDamageCont
local wtMainPanel, wtShipPanel, wtShipPlate, wtShortPanel, wtRadarPlate
local EngineSizeY = 80
local HullSizeY = EngineSizeY + 20
local dSizeX, dSizeY = 180, 150

local onEvent, onReact = {}, {}
local _PS = {}  --- 
local SHIP_MODE, RADAR_MODE = "_sh", "_rd"
local MODE = SHIP_MODE
local SHORT_MODE = false

local wtTextDsc = W("ErrorText"):GetWidgetDesc()
local dscDamVis = W("DamVis"):GetWidgetDesc()
local dscButtonCornerCrossShip = W("dscButtonCornerCrossShip"):GetWidgetDesc()
local dscButtonCornerCrossRadar = W("dscButtonCornerCrossRadar"):GetWidgetDesc()

local wts, damVisEff = {}, {}
local currHeat, wtContextActions, wtHeatID, ContextActionsFaded = 0
local TextFormat1 = ToWS("<html alignx='center' fontsize='14' shadow='1'><r name='value'/></html>")
local TextFormat2 = ToWS("<html alignx='center' fontsize='14'><r name='value'/></html>")
local TextFormatV = ToWS("<html alignx='left' fontsize='14' outline='1'><tip_golden><r name='value'/></tip_golden></html>")
local TextFormatEM = ToWS("<html alignx='left' fontsize='14' outline='1'><tip_blue><r name='value'/></tip_blue></html>")

function get_MapRadius()
	return dSizeX + _PS.ShipPlatePlace.sizeX/2
end

local demo
function toggleDemo() demo = not demo end

function Get_Panel()
	return wtShipPanel
end
function Get_RadarPlate()
	return wtRadarPlate
end

local wt250, wt450, wt800, wt1500
function repaintScale()
	local rr = 2*455^get_PS("RadarLg") / get_PS("RadarScale")
	wtSetPlace ( wt450, { sizeX = rr, sizeY = rr } )
	rr = 2*810^get_PS("RadarLg") / get_PS("RadarScale")
	wtSetPlace ( wt800, { sizeX = rr, sizeY = rr } )
	rr = 2*1510^get_PS("RadarLg") / get_PS("RadarScale")
	wtSetPlace ( wt1500, { sizeX = rr, sizeY = rr } )
end

function IsShipMode() return not SHORT_MODE and MODE == SHIP_MODE end
function IsRadarMode() return not SHORT_MODE and MODE == RADAR_MODE end
function IsShortMode() return SHORT_MODE end

local function getTimeStr( val, icon )
	if not val then
		return icon and "  " or "++"
	elseif val < 100 then
		return string.format("%02d",val)
	elseif val < 599 then
		return math.ceil(val/60).."m"
	else
		return "XX"
	end
end
local function toDamStr(num)
	if num < 1000 then
		return string.format("%g", math.ceil(num))
	elseif num < 1000000 then
		return string.format("%gK", math.ceil(num/1000))
	else
		return ""..num
	end
end
function getMyShipID()
	return myShipID
end
--function SetMyShipID( id ) myShipID = id end

local function SlotShow( slot )
	local str = ""
	for i = 0, (slot.actions or 1 ) - 1 do
		str = str ..":".. getTimeStr( slot.cd and slot.cd[i], slot.icon )
	end
	slot.wt:SetVal("value", ToWS( string.sub(str, 2) ) )
end
local function overHeat()
	return currHeat > (tonumber(_PS.overHeat) or 70)
end

local function fadeContextActionsEFF()
	if wtContextActions then wtContextActions:PlayFadeEffect( 0.2, 1, 950, EA_MONOTONOUS_INCREASE ) end
end

local function getKeySideTypeSlot( id )
	return device.GetShipSlotInfo(id).side..":"..(device.GetUsableDeviceType( id ) or "--") .. ":".. device.GetShipSlotInfo(id).interfaceSlot
end

local clrRed = {r = 1; g = 0; b = 0; a = 1}
local clrGreen = {r = 0; g = 1; b = 0; a = 1}
local function 	playEffect( slot, health )
	local v, v1 = 0, 35
	if not slot.hp then
		if health < v1 then v = v1 - health end
		slot.wtp:SetBackgroundColor( clrRed )
		slot.wtp:SetFade( slot.icon and 0 or v / 100 )
	elseif slot.hp ~= health then
		slot.wtp:SetBackgroundColor( slot.hp < health and clrGreen or clrRed )
		if health < v1 then v = v1 - health
		end
		slot.wtp:FinishFadeEffect()
		slot.wtp:PlayFadeEffect( slot.icon and 0 or v / 100, 0.7, math.ceil(3000* math.abs(slot.hp - health)/100)+500, EA_SYMMETRIC_FLASH )
	end

	slot.hp = health

end

local function HPColorSet( slot, health )
	local frmt
	local r, g, b = 0.5, 0.5, 0.5
	if health >= 95 then
		frmt = "<html alignx='center' fontsize='14' outline='1'><tip_white><r name='value'/></tip_white></html>"
		g = 0.7
		r = 0.7
		b = 0.9
	elseif health >= 75 then
		frmt = "<html alignx='center' fontsize='14' outline='1'><tip_green><r name='value'/></tip_green></html>"
		g = 0.8
		r = 0.2
		b = 0.4
	elseif health >= 50 then
		frmt = "<html alignx='center' fontsize='14' outline='1'><tip_golden><r name='value'/></tip_golden></html>"
		g = 0.8
		r = 0.8
		b = 0.1
	elseif health >= 25 then
		frmt = "<html alignx='center' fontsize='14' outline='1'><tip_red><r name='value'/></tip_red></html>"
		g = 0.3
		r = 0.9
		b = 0.2
	elseif health >= 10 then
		frmt = "<html alignx='center' fontsize='14' outline='1' class='Epic'><r name='value'/></html>"
		g = 0.3
		r = 0.6
		b = 0.0
	elseif health > 0 then
		frmt = "<html alignx='center' fontsize='14' outline='1' class='LogColorBrown'><r name='value'/></html>"
		g = 0.2
		r = 0.2
		b = 0.4
	else
		frmt = "<html alignx='center' fontsize='14' class='Dead'><r name='value'/></html>"
		g = 0.0
		r = 0.0
		b = 0.1
	end
	if slot.wti then
		slot.wti:SetBackgroundColor( { r = r, g = g, b = b, a = 1 } )
	elseif slot.icon then
	else
		slot.wt:SetFormat( ToWS(frmt) )
	end

	playEffect( slot, health )
end

local function DeviceHealthChanged( slot )
	if not slot then return end

	local id, hp = slot.id
	if device.GetHealt then
		hp = object.IsExist( id ) and device.GetHealth( id )
	elseif object.GetHealthInfo then
		hp = object.IsExist( id ) and object.GetHealthInfo( id )
	end
	if hp then
		HPColorSet( slot, hp.valuePercents or math.ceil(hp.value / hp.limit * 100) )
	end
end

local engineLowClr = { r = 0.2, g = 0.6, b = 0.2, a = 1 }
local engineOverClr = { r = 1, g = 0.3, b = 0.1, a = 1 }
local function showEngine( heat, value, limit )
	local clr, xS
	if heat < 50 then
		wtEngine:GetParent():SetBackgroundColor( { r = 0.1, g = 0.3, b = 0.1, a = 1 } )
		clr = { r = 0.2, g = 0.7, b = 0.15, a = 1 }
		wtSetPlace( wtEngine, { alignY = 1, sizeY = EngineSizeY * heat / 100} )
	elseif heat < 95 then
		wtEngine:GetParent():SetBackgroundColor( { r = 0.1, g = 0.3, b = 0.1, a = 1 } )
		clr = { r = 0.2 + 0.016 * (heat - 50 ), g = 0.7 + 0.005 * ( heat - 50 ), b = 0.15 + 0.002 * (heat - 50 ), a = 1 }
		wtSetPlace( wtEngine, { alignY = 1, sizeY = EngineSizeY * heat / 100} )
	else
		wtEngine:GetParent():SetBackgroundColor( { r = 0.2 + 0.016 * (95 - 50 ), g = 0.7 + 0.005 * ( 95 - 50 ), b = 0.15 + 0.002 * (95 - 50 ), a = 1 } )
		clr = engineOverClr
		wtSetPlace( wtEngine, { alignY = 0, sizeY = ( heat - 100 )/100 * EngineSizeY * 2} )
	end
	wtEngine:SetBackgroundColor( clr )
	wtShortEN:SetBackgroundColor( clr )
	wtSetPlace( wtShortEN, { sizeX = _PS.ShipPlatePlace.sizeX/130*heat } )
	wtShortENtxt:SetVal("value", ToWS(value.."/"..limit))
	
end

local function showHull( hpp, value, limit )
	--LogToChat("showHull"..hpp)
	local clr
	if not hpp then return
	elseif hpp > 70 then
		clr = { r = 0.6, g = 0.5, b = 0.4, a = 0.5 }
		wtSetPlace( wtHull, { alignY = 2, sizeY = HullSizeY * hpp / 100} )
	elseif hpp > 40 then
		clr = { r = 0.6 + 0.013 * (70 - hpp), g = 0.5 + 0.013 * (70 - hpp), b = 0.4 + 0.013 * (70 - hpp), a = 0.5 + 0.013 * (70 - hpp) }
		wtSetPlace( wtHull, { alignY = 2, sizeY = HullSizeY * hpp / 100} )
	else
		clr = { r = 1.0, g = 0.9, b = 0.8, a = 1 }
		wtSetPlace( wtHull, { alignY = 2, sizeY = HullSizeY * hpp / 100} )
	end
	wtHull:SetBackgroundColor( clr ) --{ r = 0.6, g = 0.5, b = 0.4, a = 0.5 }
	wtShortHP:SetBackgroundColor( clr )
	wtSetPlace( wtShortHP, { sizeX = _PS.ShipPlatePlace.sizeX/100*hpp } )
	if value then wtShortHPtxt:SetVal("value", ToWS(value.."/"..limit)) end
end


function getShieldColor(hp)
	return { r = 0.3 + (100-hp)*0.0085, g = 0.3, b = 0.75 - hp*0.003, a = 1 }
end
local function showShield(key, slot)
	local w = wtShields[key]
	if not w then return end

	local pShd = _PS.ShieldsPlace[key]
	local maxSize = pShd.pan[pShd.var]
	w:SetBackgroundColor( getShieldColor(slot.hp) )
	wtSetPlace( w, { [pShd.var] = maxSize * slot.hp / 100} )
end

local function ShieldChanded( key, idIn )
	local slot = ControlSlots[key] ---.delta = pars.strengthDelta
	local id = idIn or slot.id
	if not slot then
		---    - 
		LogInfo( "key:",key, " myShipID:", myShipID, " == device.GetTransport( id ):",device.GetTransport( id ))
		exObj("ControlSlots", ControlSlots )
	end
	if not id or not object.IsExist( id ) then return end
	local hp = math.ceil( device.GetShieldStrength( id ).value / device.GetShieldStrength( id ).maxValue * 100 )
	HPColorSet( slot, hp )
	showShield(key, slot)
end

--- ContextShipDevice:Device:Actions:Show
local function set_wtContextActions()
	local w = stateMainForm:GetChildUnchecked("ContextShipDevice", false)
	w = w and w:GetChildUnchecked("Device", false)
	--w = w and w:GetChildUnchecked("Actions", false)
	if not w then return end
	wtContextActions = w
end

--     
local function getFormatKey( mess )
	local i, j1, j2 = 0
	local key = ""
	local vals = {}
	while i do
		j1, j2 = string.find(mess, "%d+", i + 1 )
		if not j1 then break end
		table.insert( vals, tonumber( string.sub(mess, j1, j2 ) ) )
		key = key .. string.sub(mess, i+1, j1-1 ).."%d"
		i = j2
	end
	return key .. string.sub(mess, i+1 ), vals
end
local function ShowMess( frmt, vals, sender )
	local str = string.format(frmt, unpack(vals) )..( sender and " ("..FromWS(sender)..")" or "" )
	LogToChat( str )

	local w = WCD( wtTextDsc, nil, nil,{ sizeY = 40, alignY = 2, posY = 30 }, false )
	wtSetVal(w, str)
	w:Show( true )
	local wID = w:GetInstanceId()
	wts[ wID ] = w
	w:PlayFadeEffect( 1, 0.7, 8000, EA_MONOTONOUS_INCREASE )
	local p = w:GetPlacementPlain()
	local pp = Clone( p )
	pp.posY = 100
	w:PlayMoveEffect( p, pp, 4000, EA_MONOTONOUS_INCREASE )
	return wID
end
local function ShowMess2( frmt, vals, sender )
	local str = string.format(frmt, unpack(vals) )..( sender and " ("..FromWS(sender)..")" or "" )

	local w = WCD( wtTextDsc, nil, nil,{ sizeY = 40, alignY = 1, highPosY = 100 }, false )
	wtSetVal(w, str)
	w:Show( true )
	local wID = w:GetInstanceId()
	wts[ wID ] = w
	w:PlayFadeEffect( 1, 0.7, 8000, EA_MONOTONOUS_INCREASE )
	local p = w:GetPlacementPlain()
	local pp = Clone( p )
	pp.highPosY = 200
	w:PlayMoveEffect( p, pp, 4000, EA_MONOTONOUS_INCREASE )
	return wID
end

local formaDamVis = ToWS("<html shadow='1'><tip_blue><r name='shieldD'/></tip_blue> <tip_red><r name='hullD'/></tip_red> <tip_golden><r name='deviceD'/></tip_golden></html>")

local function showDamage( side, shieldDamage, hullDamage, deviceDamage )
	if not MODE == SHIP_MODE then return end
	--LogInfo( side,":", toDamStr(hullDamage),":", toDamStr(shieldDamage),":", toDamStr(deviceDamage) )
--[[
	[SHIP_SIDE_FRONT] = {},
	[SHIP_SIDE_REAR] = {},
	[SHIP_SIDE_LEFT] = {},
	[SHIP_SIDE_RIGHT] = {},
]]
	local pop, w
	--[[
	valuedText:ClearValues() ---  
	valuedText:SetVal( "hullD", ToWS(""..hullDamage) )
	valuedText:SetVal( "shieldD", ToWS(""..shieldDamage) )
	valuedText:SetVal( "deviceD", ToWS(""..deviceDamage) )
	]]
	local sH, sS, sD = toDamStr(hullDamage), toDamStr(shieldDamage), toDamStr(deviceDamage)
	local len = string.len(sH) + string.len(sS) + string.len(sD) + 2
	local wtDVEff
	--            
	for _, eff in damVisEff do
		if eff.del then
			wtDVEff = eff
			break
		end
	end
	if wtDVEff then
		wtDVEff.del = nil
		w = wtDVEff.w
	else
		w = WCD( dsc.Text, nil, nil, {alignY = 1, highPosY = 0, alignX = 0, sizeY = 20 }, false )
		w:SetEllipsis( false )
		w:SetFormat(formaDamVis)
		wtDVEff = { w = w }
		damVisEff[w:GetInstanceId()] = wtDVEff
	end
	wtSetPlace( w, { sizeX = 10*len+10 })
	w:SetVal( "hullD", ToWS(sH) )
	w:SetVal( "shieldD", ToWS(sS) )
	w:SetVal( "deviceD", ToWS(sD) )
	w:Show(true)

	if side == SHIP_SIDE_REAR then
		wtDamageCont[side]:PushFront( w )
		wtDVEff.pop = 1
	else
		wtDamageCont[side]:PushBack( w )
	end
	wtDVEff.wtCont = wtDamageCont[side]
	w:PlayFadeEffect( 1, 0.3, 9700, EA_MONOTONOUS_INCREASE )

end


onEvent.EVENT_EFFECT_FINISHED = function( pars )
	local wID = pars.wtOwner:GetInstanceId()
	local obj = wts[ wID ]
	local objDV = damVisEff[ wID ]
	if obj then
		if wtHeatID and wtHeatID == wID then wtHeatID = nil end
		if pars.effectType ~= ET_FADE then return end
		wts[wID] = nil
		obj:DestroyWidget()
	elseif objDV and pars.effectType == ET_FADE then
		if objDV.pop then objDV.wtCont:PopBack()
		else objDV.wtCont:PopFront() end

		objDV.del = true
		--objDV.w:DestroyWidget()
	end

end

local sec1, sec2, side, odd, hpp = 45, 55, 3, 1, 100
local damSHkey, damKey
onEvent["EVENT_SECOND_TIMER"] = function ( pars )
	if ContextActionsFaded then fadeContextActionsEFF() end
	if myShipID then
		----  
		for k, slot in ControlSlots do
			if slot.cd then
				for i, val in slot.cd do
					if not val then
						--- 
					elseif val > 1 then
						slot.cd[i] = val - 1
					else
						slot.cd[i] = nil
					end
				end
			end
			if slot.id then
				if not demo then DeviceHealthChanged( slot ) end
				SlotShow( slot )
			end
		end
		onEvent.EVENT_TRANSPORT_HEALTH_CHANGED ( { id = myShipID } )


		if demo then
			local energy = transport.GetEnergy( myShipID )
			sec1 = sec1 + 5 if sec1 > 135 then sec1 = 0 end showEngine(sec1, math.ceil(energy.limit*sec1/100), energy.limit)
			local hp, value, limit = transport_GetHealth( myShipID )
			sec2 = sec2 + 4 if sec2 > 100 then sec2 = 0 end showHull(sec2, math.ceil(limit*sec2/100), limit)
			damSHkey = next(wtShields, damSHkey)
			if damSHkey then
				HPColorSet( ControlSlots[damSHkey], math.ceil(math.random() * 100) )
				showShield(damSHkey, ControlSlots[damSHkey])
			end
			side = side + 1 if side > 5 then side = 2 end
			showDamage( side, math.ceil(math.random() * 10000), math.ceil(math.random() * 1000), math.ceil(math.random() * 100) )
			odd = odd + 1
			if odd > 1 then
				odd = 0
				showDamage( side, math.ceil(math.random() * 10000), math.ceil(math.random() * 1000), math.ceil(math.random() * 100) )
				showDamage( side, math.ceil(math.random() * 10000), math.ceil(math.random() * 1000), math.ceil(math.random() * 100) )
			end
			
			damKey = next(ControlSlots, damKey)
			while wtShields[damKey] do
				damKey = next(ControlSlots, damKey)
			end
			if damKey and ControlSlots[ damKey ].wti and '2:1:1' ~= damKey and '2:1:2' ~= damKey then
				local slot = ControlSlots[ damKey ] 
				HPColorSet( slot, math.ceil(math.random() * 100) )
				if not slot.cd then slot.cd = {} end
				if odd == 1 and not slot.cd[ 0 ] then
					slot.cd[ 0 ] = math.ceil(math.random() * 140)
				end
				--SlotShow( slot )

			end
			HPColorSet( ControlSlots[ '2:1:1' ], hpp ) hpp = hpp-3 if hpp<0 then hpp = 100 end
			if side == 3 then HPColorSet( ControlSlots[ '2:1:2' ], odd*2 ) end
			

		end
		
	end
end

function listDevs()
	if not myShipID or not transport.CanDrawInterface(myShipID) then return end
	for _, id in transport.GetDevices(myShipID) do
		local key, name = getKeySideTypeSlot( id ), FromWS( object.GetName( id ) )
		LogInfo( ( ControlSlots[key] and "-- " or "") .. "['"..key.."'] = { place = { alignX = 0, posX = 0, highPosX = 0, alignY = 0, posY = 0, highPosY = 0 }, actions = 1 }, "
			.. " -- ".. name)
	end
end
local function GetCoolDown( slot, action )
	if slot.noActions then return end
	local CD =  slot.id and object.IsExist( slot.id ) and device.GetCooldown( slot.id, action )
	if not CD then return end
	local act
	if slot.onlyActions then
		for i, v in slot.onlyActions do
			if action == v then
				act = i - 1
				break
			end
		end
	else
		act = action
	end
	if not act then return end
	if not slot.cd then slot.cd = {} end
	slot.cd[ act ] = math.ceil(CD.remainingMs/1000)
	SlotShow( slot )
end

local function add_slot( id )
	local key = getKeySideTypeSlot( id )
	local slot = ControlSlots[key]
	if slot then
		slot.id = id
		slot.name = FromWS( object.GetName( id ) )
		slot.w:Show( true )
		DeviceHealthChanged( slot )
		if slot.onlyActions then
			for _, action in slot.onlyActions do
				GetCoolDown( slot, action )
			end
		else
			for action=0, (slot.actions or 1)-1 do
				GetCoolDown( slot, action )
			end
		end
	end
end

local function ShowPanels( on )
	if SHORT_MODE then
		wtShortPanel:Show( on )
	else
		wtShipPanel:Show( on )
	end
end

local function AvatarShip( idIn )
	myShipID = idIn or unit.GetTransport(myID)
	if myShipID and transport.CanDrawInterface(myShipID) then

		SetImageMyShip( myShipID )

		wtName:SetVal("value",object.GetName(myShipID) )
		for _, slot in ControlSlots do
			slot.w:Show( false )
		end
		for _, id in transport.GetDevices(myShipID) do
			add_slot( id )
		end
		onEvent.EVENT_TRANSPORT_ENERGY_CHANGED ( { id = myShipID } )
		onEvent.EVENT_TRANSPORT_HEALTH_CHANGED ( { id = myShipID } )
		onEvent.EVENT_TRANSPORT_INSIGHT_CHANGED ( { id = myShipID } )
		onEvent.EVENT_TRANSPORT_HORIZONTAL_VELOCITY_CHANGED ( { id = myShipID } )
		for k in wtShields do
			ShieldChanded( k )
		end

		ShowPanels( true )
		--exObj("Astoplabe", transport.GetAstrolabeInfoEx( myShipID ) )

	else
		ShowPanels( false )
	end
end

onEvent["EVENT_USABLE_DEVICE_SPAWNED"] = function ( pars )
	local id = pars.id
	---        !
	if not (myShipID and myShipID == device.GetTransport( id ) --[[ and transport.CanDrawInterface(myShipID) ]] ) then return end
	---    
	add_slot(id)
end

onEvent["EVENT_AVATAR_TRANSPORT_CHANGED"] = function ( pars )
	--LogToChat( "EVENT_AVATAR_TRANSPORT_CHANGED" )
	AvatarShip()
end

--[[onEvent["EVENT_TRANSPORT_DEVICES_CHANGED"] = function ( pars )
	LogToChat( "EVENT_TRANSPORT_DEVICES_CHANGED" )
	AvatarShip( pars.id )
end
]]

--[[
onEvent["EVENT_TRANSPORT_SPAWNED"] = function ( pars )
	LogToChat( "EVENT_TRANSPORT_SPAWNED " .. FromWS( object.GetName( pars.id ) ) )
	if myShipID and myShipID == pars.id then AvatarShip( pars.id ) end
end
]]

onEvent["EVENT_DEVICE_COOLDOWN_STARTED"] = function ( pars )
	local id = pars.id
	---        !
	if not (myShipID and myShipID == device.GetTransport( id ) --[[ and transport.CanDrawInterface(myShipID) ]] ) then return end
	---    
	local key = getKeySideTypeSlot( id )
	local slot = ControlSlots[key]
	if not slot then return end
	GetCoolDown( slot, pars.action )
end

--[[
onEvent["EVENT_DEVICE_ACTIVE_ACTION_CHANGED"] = function ( pars )
	--LogInfo( "EVENT_DEVICE_ACTIVE_ACTION_CHANGED".. FromWS(object.GetName( pars.id )) )
	exObj( "EVENT_DEVICE_ACTIVE_ACTION_CHANGED".. FromWS(object.GetName( pars.id )), pars )
end
]]
--[[            
Info: addon ShipControl: EVENT_DEVICE_CHANGED {
Info: addon ShipControl: EVENT_DEVICE_CHANGED .deviceId=450979
Info: addon ShipControl: EVENT_DEVICE_CHANGED }
onEvent["EVENT_DEVICE_CHANGED"] = function ( pars )
	--LogInfo( "EVENT_DEVICE_CHANGED".. FromWS(object.GetName( pars.deviceId )) )
	exObj( "EVENT_DEVICE_CHANGED".. FromWS(object.GetName( pars.deviceId )), pars )
	LogToChat( "EVENT_DEVICE_CHANGED".. FromWS(object.GetName( pars.deviceId )) )
end
]]

---    
function transport_GetHealth( id )
	local hp
	if transport.GetHealth then
		hp = transport.GetHealth(id)
	else
		hp = object.GetHealthInfo(id)
	end
	if hp then return hp.valuePercents or math.ceil(hp.value / hp.limit * 100), hp.value, hp.limit end
end

onEvent["EVENT_TRANSPORT_HEALTH_CHANGED"] = function ( pars )
	if pars.id and pars.id == myShipID then
		--LogToChat("EVENT_TRANSPORT_HEALTH_CHANGED")
		showHull( transport_GetHealth( pars.id ) )
	end
end
onEvent["EVENT_SHIP_DAMAGE_RECEIVED"] = function ( pars )
--[[ :    :
attacker: ObjectId (or nil) - id    ,   .
defender: ObjectId (or nil) - id    ,   .
damageSource: ObjectId (or nil) - id  ,    ().
attackerPlayer: ObjectId (or nil) - id ,   .
side: number (enum SHIP_SIDE_...) -  ,   
totalDamage: number (int)  ,  
hullDamage: number (int) ,   
shieldDamage: number (int)  ,   
deviceDamage: number (int)  ,     
isCritical: boolean - true -   
isGlancing: boolean - true -   
isLethal: boolean - true -      
]]
	if pars.defender ~= myShipID then return end
	--- -   EVENT_TRANSPORT_HEALTH_CHANGED   
	showHull( transport_GetHealth( myShipID ) )
	showDamage( pars.side, pars.shieldDamage, pars.hullDamage, pars.deviceDamage )
	
end

onEvent["EVENT_DEVICE_HEALTH_CHANGED"] = function ( pars )
	local id = pars.id
	---        !
	if not (myShipID and myShipID == device.GetTransport( id ) --[[ and transport.CanDrawInterface(myShipID) ]] ) then return end
	---    

	local slot = ControlSlots[getKeySideTypeSlot( id )]
	DeviceHealthChanged( slot )
end

onEvent["EVENT_SHIELD_STRENGTH_CHANGED"] = function ( pars )
	local id = pars.id
	---        !
	if not (myShipID and myShipID == device.GetTransport( id ) --[[ and transport.CanDrawInterface(myShipID) ]] ) then return end
	---    
	local key = getKeySideTypeSlot( id )
	ShieldChanded( key, id )
end

onEvent["EVENT_TRANSPORT_ENERGY_CHANGED"] = function ( pars )
	if pars.id ~= myShipID then return end

	local energy = transport.GetEnergy( pars.id )
	if energy then
		currHeat = math.floor( energy.value / energy.limit * 100 )
		showEngine(currHeat, energy.value, energy.limit )
		ContextActionsFaded = overHeat()

		if ContextActionsFaded then
			if not wtHeatID then
				wtHeatID = ShowMess2( "   %d", { currHeat } )
			end
		end
	else
		ContextActionsFaded = nil
	end
end

local InsightVal
onEvent["EVENT_TRANSPORT_INSIGHT_CHANGED"] = function ( pars )
	if pars.id == myShipID then
		InsightVal = transport.GetInsight(myShipID)
		wtInsight:SetVal("value", ToWS("["..InsightVal.."]") )
	end
end
onEvent["EVENT_TRANSPORT_HORIZONTAL_VELOCITY_CHANGED"] = function ( pars )
	if pars.id == myShipID then
		local vs = transport.GetVelocities(myShipID)
		wtHVelocity:SetVal("value", ToWS( string.format("V:%g", math.ceil( vs.horizontal*10 )/10 ) ) )
	end
end

local placeOld
onEvent["MAP_CHANGE_VISIBILITY"] = function ( pars )
	if _PS.OverMapShow ~= ON then return end
	if pars.priority then
		placeOld = wtMainPanel:GetPlacementPlain()
		wtSetPlace( wtMainPanel, _PS.OverMapPlace )
		mainForm:SetPriority( pars.priority + 100 )
	else
		wtMainPanel:SetPlacementPlain(placeOld)
		mainForm:SetPriority(_PS.prior)
	end
end

-------------- REACTIONS --------------
---------------------------------------
onReact[ "mouse_left_click" ] = function( reaction )
	if DnD:IsDragging() then return end

	--local parent = reaction.widget:GetParent()
	if false then
	elseif reaction.sender == "ButtonCornerCross" then
		--[[
		ShipPlateShow = not ShipPlateShow
		local p
		if ShipPlateShow then
			p = wtShortPanel:GetPlacementPlain()
			wtSetPlace( wtShipPanel, { posX = p.posX - dSizeX, posY = p.posY - dSizeY } )
			wtShip:AddChild(reaction.widget)
		else
			p = wtShipPanel:GetPlacementPlain()
			wtSetPlace( wtShortPanel, { posX = p.posX + dSizeX, posY = p.posY + dSizeY } )
			wtShortPanel:AddChild(reaction.widget)
		end
		wtShipPanel:Show( ShipPlateShow )
		wtShortPanel:Show( not ShipPlateShow )
		]]
		if MODE == SHIP_MODE then
			MODE = RADAR_MODE
			wtShipPlate:Show( false )
			repaint()
			wtRadarPlate:Show( true )
		elseif MODE == RADAR_MODE then
			MODE = SHIP_MODE
			wtRadarPlate:Show( false )
			repaint()
			wtShipPlate:Show( true )
		end
	elseif reaction.sender == "ButtonCornerCrossShort" then
		SHORT_MODE = not SHORT_MODE
		wtShortPanel:Show( SHORT_MODE )
		repaint()
		wtShipPanel:Show( true )
	end
end
onReact[ "mouse_right_click" ] = function( reaction )
	if false then
	elseif reaction.sender == "ButtonCornerCross" then
		wtShipPanel:Show( SHORT_MODE )
		SHORT_MODE = not SHORT_MODE
		wtShortPanel:Show( SHORT_MODE )
	end
end
onReact[ "panel_over" ] = function( reaction )
	local slot = ControlSlots[reaction.widget:GetName()]
	if not slot then return end
	show_tip( { slot = slot }, reaction.active, reaction.widget )
end
--[[onReact[ "mouse_double_click" ] = function( reaction )
	LogToChat("mouse_double_click")
end
]]


-----------------------------------------
---------------- INIT -------------------
-----------------------------------------

function ShipPanelInit()
	local w, wt, wp, wi, tr, pl
	local pAll = Clone(_PS.ShipPlatePlace)
	pAll.sizeX = _PS.ShipPlatePlace.sizeX + dSizeX * 2
	pAll.sizeY = _PS.ShipPlatePlace.sizeY + dSizeY * 2
	-- WCD(descr, name, parent, place, show )
	wtMainPanel = WCD( dsc.Panel, "MainPanel", nil, pAll, true )

	wtShipPanel = WCD( dsc.Panel, "ShipPanel", wtMainPanel, { alignX = 3, alignY = 3 }, true )
	wtShipPlate = WCD( dsc.Menu, "Ship", wtShipPanel, { alignX=2, alignY=2, sizeX = _PS.ShipPlatePlace.sizeX, sizeY = _PS.ShipPlatePlace.sizeY, highPosY = 20}, true )
	wtShipPlate:SetBackgroundColor( { r = 0, g = 0, b = 0, a=0.4 } )

	wt = WCD( dscButtonCornerCrossShip, "ButtonCornerCross", wtShipPlate, { }, true )
	wt:SetPriority( 500 )
	DnD:Init(wt, wtMainPanel, true, false )

	wtRadarPlate = WCD( dsc.Panel, "Radar", wtShipPanel, { alignX=3, alignY=3, }, false )
	--wtRadarPlate:SetBackgroundColor( { r = 0, g = 0, b = 0, a=0.2 } )
	wt = WCD( dscButtonCornerCrossRadar, "ButtonCornerCross", wtRadarPlate, { alignX = 1, alignY = 1, highPosX = dSizeX/2, highPosY = dSizeY/2 }, true )
	wt:SetPriority( 500 )
	DnD:Init(wt, wtMainPanel, true, false )

	wtShortPanel = WCD( dsc.Panel, "Short", wtMainPanel, { posX = dSizeX, posY = dSizeY, sizeX = _PS.ShipPlatePlace.sizeX, sizeY = 75}, false )
	wt = WCD( dsc.ButtonCornerCross, "ButtonCornerCrossShort", wtShortPanel, {}, true )
	wt:SetPriority( 500 )
	DnD:Init(wt, wtMainPanel, true, false )

	ControlSlots = {}
	for k, v in _PS.ControlSlots do
		w = WCD( dsc.Panel, k.."_pan", wtShipPlate, { sizeX = (v.actions or 1 )*3*9 + 5, sizeY = _PS.TextSize.sizeY + 0}, true )
		wtSetPlace( w, v.place)
		w:SetPriority( 5 )
		pl = w:GetPlacementPlain()
		wt = WCD( dsc.Text, "txt", w, { alignX = 3, alignY = 3}, true )
		wt:SetEllipsis( false )
		wt:SetFormat(TextFormat1)
		wt:SetPriority( 10 )
		---       = 
		wp = WCD( dsc.PanelER, k, w, { alignX = 3, alignY = 3}, true )
		--wp:SetPlacementPlain( pl )
		wp:SetFade ( 0 )
		wp:SetPriority( 5 )
		wi = nil
		if v.icon == "-" then
		elseif v.icon then
			tr = common.GetAddonRelatedTexture( v.icon )
			if tr then
				wi = WCD( dsc.PanelEmpty, "icon", w, { alignX = 3, alignY = 3 }, true )
				if v.iconPlace then wtSetPlace( w, v.iconPlace) end
				wi:SetPriority( 4 )
				wi:SetBackgroundTexture( tr )
				--wi:SetFade ( 0.5 )
				--wtHull:SetBackgroundColor( clr ) --{ r = 0.6, g = 0.5, b = 0.4, a = 0.5 }
			if v.rotate and v.rotate ~= 0 then
				wi:Rotate( v.rotate / 180 * 3.1416 )
			end
			end
		else
		end
		ControlSlots[k] = { w = w, wt = wt, wtp = wp, actions = v.actions, wti = wi, icon = v.icon, onlyActions = v.onlyActions, noActions=v.noActions }
	end
	--- shields plates
	wtShields = {}
	for k, places in _PS.ShieldsPlace do
		w = WCD( dsc.PanelEmpty, k.."_sld_pan", wtShipPlate, places.pan, true )
		w:SetBackgroundColor( { r = 0.1, g = 0.1, b = 0.2, a = 1 } )
		w:SetPriority( 0 )
		if ControlSlots[k] then
			w:AddChild( ControlSlots[k].wtp )
			wtSetPlace( ControlSlots[k].wtp, {alignX = 3, posX = 0, highPosX = 0, alignY = 3, posY = 0, highPosY = 0, } )
			--ControlSlots[k].wtp:SetPriority( 0 )
		end
		---       = 
		w = WCD( dsc.PanelER, k.."_shd", w, places.sld, true )
		w:SetPriority( 0 )
		wtShields[k] = w
	end
	w = WCD( dsc.PanelER, "hull_Pan", wtShipPlate, {alignY = 2, posY = -0, alignX = 2, posX = 0, sizeY = HullSizeY, sizeX = 60}, true )
	w:SetBackgroundColor( { r = 0.0, g = 0.0, b = 0.0, a = 1 } )
	w:SetPriority( 0 )
	wtHull = WCD( dsc.PanelER, "hull", w, {alignY = 2, alignX = 3, sizeY = HullSizeY}, true )
	w = WCD( dsc.PanelER, "engine_Pan", wtShipPlate, {alignY = 2, posY = -0, alignX = 2, posX = 0, sizeY = EngineSizeY, sizeX = 30}, true )
	w:SetBackgroundColor( { r = 0.0, g = 0.0, b = 0.1, a = 1 } )
	w:SetPriority( 1 )
	wtEngine = WCD( dsc.PanelER, "engine", w, {alignY = 2, alignX = 3, sizeY = EngineSizeY }, true )

	wtName = WCD( dsc.Text, "name", wtShortPanel, {alignY = 0, posY = 0, alignX = 3, sizeY = 20 }, true )
	wtName:SetFormat(ToWS("<html alignx='left' fontsize='16' outline='1'><tip_golden><r name='value'/></tip_golden></html>"))
	wtName:SetPriority( 10 )
	
	--wtVVelocity = WCD( dsc.Text, "VV", wtMainPanel, {alignY = 1, alignX = 2, }, true )
	wtShortHP = WCD( dsc.Bar, "_HP", wtShortPanel, {alignY = 1, alignX = 0, highPosY=20, sizeY = 30, sizeX = _PS.ShipPlatePlace.sizeX}, true )
	wtShortHPtxt = WCD( dsc.Text, "_HPtxt", wtShortPanel, {alignY = 1, alignX = 1, highPosY=22, sizeY = 20, sizeX = PS.ShipPlatePlace.sizeX }, true )
	wtShortHPtxt:SetPriority( 10 )
	wtShortHPtxt:SetFormat( ToWS("<html alignx='right' font-name='AllodsSystem' fontsize='16' outline='1'><r name='value'/></html>") )
	wtShortEN = WCD( dsc.Bar, "_EN", wtShortPanel, {alignY = 1, alignX = 0, sizeY = 20, sizeX = _PS.ShipPlatePlace.sizeX}, true )
	wtShortENtxt = WCD( dsc.Text, "_ENtxt", wtShortPanel, {alignY = 1, alignX = 0, sizeY = 20, sizeX = _PS.ShipPlatePlace.sizeX }, true )
	wtShortENtxt:SetPriority( 10 )
	wtShortENtxt:SetFormat( ToWS("<html alignx='right' font-name='AllodsSystem' fontsize='16' outline='1'><tip_golden><r name='value'/></tip_golden></html>") )

	wtInsight = WCD( dsc.Text, "insight", wtShortPanel, {alignY = 1, alignX = 0, posX = 50, sizeX = 120, sizeY = 20 }, true )
	wtInsight:SetFormat(TextFormatEM)
	wtInsight:SetPriority( 5 )
	wtHVelocity = WCD( dsc.Text, "HV", wtShortPanel, {alignY = 1, alignX = 0, posY = 0, sizeX = 80, sizeY = 20 }, true )
	wtHVelocity:SetFormat(TextFormatV)
	wtHVelocity:SetPriority( 5 )

	wtDamageCont = {}
	---w = W("damVisFront") --wtSetPlace(w, {alignY = 0, alignX = 2, sizeX = dSizeX, sizeY = dSizeY } )
	w = WCD( dscDamVis, nil, wtMainPanel, nil, true )
	wtSetPlace(w, {alignY = 1, highPosY = _PS.ShipPlatePlace.sizeY + dSizeY, alignX = 2 } )
	wtDamageCont[ SHIP_SIDE_FRONT ] = W("Container", w )
	w = WCD( dscDamVis, nil, wtMainPanel, nil, true )
	wtSetPlace(w, {alignY = 0, posY = _PS.ShipPlatePlace.sizeY + dSizeY, alignX = 2 } )
	wtDamageCont[ SHIP_SIDE_REAR ] =  W("Container", w )
	w = WCD( dscDamVis, nil, wtMainPanel, nil, true )
	wtSetPlace(w, {alignY = 1, highPosY = _PS.ShipPlatePlace.sizeY/2 + dSizeY*0.7, alignX = 1, highPosX = _PS.ShipPlatePlace.sizeX + dSizeX,  } )
	wtDamageCont[ SHIP_SIDE_LEFT ] =  W("Container", w )
	w = WCD( dscDamVis, nil, wtMainPanel, nil, true )
	wtSetPlace(w, {alignY = 1, highPosY = _PS.ShipPlatePlace.sizeY/2 + dSizeY*0.7, alignX = 0, posX = _PS.ShipPlatePlace.sizeX + dSizeX,  } )
	wtDamageCont[ SHIP_SIDE_RIGHT ] =  W("Container", w )
	
	wt450 = WCD( dsc.PanelEmpty, "d450",  wtRadarPlate, { alignX = 2, alignY = 2, }, true )
	wt450:SetBackgroundTexture( common.GetAddonRelatedTexture( "scale450b" ) )
	wt450:SetPriority(0)
	wt450:SetBackgroundColor( { r = 1.0, g = 1.0, b = 1.0, a = 0.4 } )

	wt800 = WCD( dsc.PanelEmpty, "d800",  wtRadarPlate, { alignX = 2, alignY = 2, }, true )
	wt800:SetBackgroundTexture( common.GetAddonRelatedTexture( "scale800" ) )
	wt800:SetPriority(0)
	wt800:SetBackgroundColor( { r = 1.0, g = 1.0, b = 1.0, a = 0.4 } )

	wt1500 = WCD( dsc.PanelEmpty, "d1500",  wtRadarPlate, { alignX = 2, alignY = 2, }, true )
	wt1500:SetBackgroundTexture( common.GetAddonRelatedTexture( "scale800a" ) )
	wt1500:SetPriority(0)
	wt1500:SetBackgroundColor( { r = 1.0, g = 1.0, b = 1.0, a = 0.4 } )

	
end

------------- init functions -------------
function toConfig()
	local cfg = {}
	for k, v in _PS do
		if not PS[k] or PS[k] ~= v then
			---       config.txt  
			---     user.cfg
			cfg[k] = v
		end
	end
	userMods.SetAvatarConfigSection( ADDONname, cfg )
	LogToChat(L("saved"))
end

function fromConfig()
	reset_PS()
	local cfg = userMods.GetAvatarConfigSection( ADDONname ) or {}
	for k, v in cfg do
		_PS[k] = v
	end
	menuUpdate()
	LogToChat(L("loaded"))
end

function loadUnloadedAddons()
--	LogToChat(L("nothing to load"))
end

get_PS = function( key )
	return _PS[key]
end
set_PS = function( key, val )
	_PS[key] = val
end

reset_PS = function()
	_PS = {} ---   
	for k, v in PS do
		_PS[k] = v
	end
	menuUpdate()
end

function mainInit()
	---         AddonsMenu  
	---         

	fromConfig()

	GUIinit()
	
	myID = avatar.GetId()
	ShipPanelInit()
	set_wtContextActions()

	AvatarShip()

	--[[
	           -          
	]]
	RegisterEventHandlers( onEvent )
	RegisterReactionHandlers( onReact )

	ShortMap_Init()


end
