local wTip, wTipTxt
local function tip_init()
	wTip = mainForm:CreateWidgetByDesc( dsc.Border )
	wTipTxt = mainForm:CreateWidgetByDesc( dsc.Text )
	wTip:AddChild(wTipTxt) wTipTxt:Show(true)
	wTipTxt:SetMultiline( true )
	wtSetPlace( wTipTxt, { posX=20, highPosX=20, posY=20, highPosY=20, alignX = 3, alignY = 3 } )
	wTipTxt:SetFormat( ToWS("<html alignx='left' aligny='middle' fontname='AllodsWest' fontsize='14' shadow='1'><log_dark_white><r name='value'/> <r name='nameVT'/></log_dark_white></html>"))
	--wtSetPlace( wTipTxt, { posX=20, highPosX=20, posY=20, highPosY=20, alignX = 3, alignY = 3 } )
	wTip:SetPriority( 500 ) ---or .wtMenu:GetPriority())+100)
end

function show_tip( pars, active, wBase )
	if active == true then
		--exObj("pars", pars)
		wTipTxt:ClearValues()
		local str, nameVT
		if pars.slot then
			str = pars.slot.hp and ( "HP:"..pars.slot.hp .. "%  " ) or "" --FromWS( device.GetTitle(slot.id) ).."  " ..
			if "<html>" == string.sub( pars.slot.name , 1, 6 ) then
				---    -  HTML
				nameVT = common.CreateValuedText()
				nameVT:SetFormat( ToWS(pars.slot.name) )
			else 
				str = str .. (pars.slot.name or "")
			end
		elseif pars.obj then
			str = FromWS( pars.obj.name )..".".. (pars.obj.description and "   "..FromWS( pars.obj.description ).."." or "")
				.. (pars.obj.hpp and "  HP:"..pars.obj.hpp.."%" or "")
				.. (pars.obj.dist and L("  DIST:")..math.ceil(pars.obj.dist)..L("m").."." or "")
				.. (pars.obj.deltaZt and math.abs(pars.obj.deltaZt) > 1 and L("   H:")..pars.obj.deltaZt..L("m").."." or "")
		end
		wTipTxt:SetVal("value", ToWS( str ) )
		if nameVT then wTipTxt:SetVal("nameVT", nameVT ) end
		wtSetPlace( wTip, { sizeX = 350, sizeY=130 } )
		wtChain( wTip, wBase, 10, 10)
		--LogToChat( str )
	end
	
	wTip:Show( active )
end

-----------------------------------------------------------------------------------------------

local mnu

--[[
   :
	.value
  -          - Update():
	.valGet = function(item) or table[item.name]
	-     .value
   :
	.valOnSet = function(item)
	       (     )

     :
1.     -   
	.valLabels = function(item) or table[item.value]
	-    
	VAL = 
2.       VAL  SetFormat():
	.valFormats = table[VAL]
3.     (    ):
	.valShapes = function(VAL) or table[VAL]
	-      :SetVal()

   :
	.label -  
	.labelShapes = function(label) or table[label]
	-   -   

            :
	if item.valGet then
	elseif item.parent.valGet then
	end
	if item.labelShapes then
	elseif item.parent.labelShapes then
	end

     -        :
	.onClick = function( item )

	---          /   
	local onClick = item.onClick or item.valOnSet or obj.valOnSet or obj.onClick
	if onClick then onClick( item, pars ) end

]]
local valFormats = { 
	[names[ON]] = "<html alignx='right' fontsize='14'><tip_green><r name='value'/></tip_green></html>",
	[names[OFF]] = "<html><log_dark_white><body alignx='right' fontsize='14'><r name='value'/></body></log_dark_white></html>",
	}

local function valGet(item)
	--LogInfo( item.name )
	return get_PS( item.name )
	--LogInfo( item.value )
	
end

local function reLoad()
	common.StateUnloadManagedAddon( "UserAddon/"..ADDONname )
	common.StateLoadManagedAddon( "UserAddon/"..ADDONname )
end
local function toConfig_RE()
	toConfig()
	reLoad()
end
local function fromConfig_RE()
	fromConfig()
	reLoad()
end
local function reset_PS_RE()
	reset_PS()
	reLoad()
end

local function valOnSetRe( item )
	local n, v = item.name, tonumber(item.value) or item.value
	set_PS(n, v)
	toConfig_RE()
end

local function valOnSet( item )

	local n, v = item.name, tonumber(item.value) or item.value
	set_PS(n, v)

	item.parent:ItemFade( item, v == OFF and 0.7 or 1)
	if type(v) ~= "table" then
		--LogToChat(n.." = "..v)
	else
		--LogToChat("see mods.txt")
		--exObj( n, v )
	end
end
local function setLocalize(item)
	valOnSet( item )
	SetGameLocalization(item.value)
	mnu:Update()
end

-------------------------------------------------------------------------------
function mainMenuToggle( pars )
	if mnu then
		---exObj("pars",pars)
		if not DnD:isSetted( mnu.wtMenu ) then
			---           , 
			---   
			wtChain( mnu.wtMenu, pars.reaction.widget , 10, 10 )
		end
		mnu:Show( true )
	else ---LogInfo("mainMenu.ShowToggle - mnu = nil")
	end
end

function AOCommand( pars )
	if pars.command == "cmd1" then
		LogToChat("You select FIRST command")
	elseif pars.command == "cmd2" then
		LogToChat("You select command 2")
	end
	
end
----------------------------------------------------------------
------ INIT
----------------------------------------------------------------
function menuUpdate()
	if mnu then mnu:Update() end
end


---  ,       
local onoff = { ON, OFF }

function GUIinit()

	local strucMenu = 
	{
		{ token = "_", label = "COMMANDS", },
		{ name = "load", label = "Load Settings", onClick = fromConfig_RE },
		{ name = "save", label = "Save Settings", onClick = toConfig_RE },
		{ token = "_", label = "", },
		{ name = "_", label = "List Devices to mods.txt", onClick = listDevs },
		{ name = "_", label = "Run DEMO mode", onClick = function() if not toggleDemo() then reLoad() end end },
		{ token = "_", label = "", },
		{ token = "_", label = "SETTINGS", },
		{ name = "prior", label = "Inteface Priority", type = "_edl", chars=5 },
		{ name = "overHeat", label = "Ship Over Heat", type = "_edl", chars=2 },
		{ name = "RadarScale", label = "Radar Scale", type = "_edl", chars=2, valOnSet = valOnSetRe },
		{ name = "RadarLg", label = "Radar Power koeff", type = "_edl", chars=2, valOnSet = valOnSetRe },
		{ name = "RadarEdge", label = "Edge of the Radar", type = "_edl", chars=2, valOnSet = valOnSetRe },

		{ name = "DistMobs1", label = "Mobs Radar Radius", type = "_edl", chars=4, valOnSet = valOnSetRe },
		{ name = "OverMapShow", label = "Show Over Map", type = "_txt", listVals = onoff },
		{ name = "OverMapPlace", label = "Over Map Place", type ="_lst", 
			list = {
				itemSizeX = 300,
				type = "_edl", --labels = allTypes, vals = sortVals, valLabels = names, defaultVal = SORT_ASC,
				edited = true, ---   
				numberKeys = false, ---      -          
				},
			offset = 15, tip = L("window Offset when map open") },
		{ token = "_", label = "", },
		{ token = "_3", label = "------***------", },
		{ name = "reset", label = "Reset to Config.txt", onClick = reset_PS_RE },
		{ name ="listTexts", label =L("list Texts to mod.txt"), onClick = listTexts, tip="for translation - use after showing the entire interface" },
	}

	mnu = menu{ strucMenu = strucMenu, priority = 500, mouse_overRun = true, fadeOn = 100, fadeOff = 600,
		valGet = valGet, ---       
		labelShapes = L, ---  
		valOnSet = valOnSet, --- ,         
		valFormats = valFormats, ---   ( ...)   
		valShapes = L, ---  
		itemSizeX = 300,
	}
	mnu:init({})
	DnD:Init( mnu.wtMenu, mnu.wtMenu, false)

	tip_init()

	local w = stateMainForm:GetChildUnchecked("ContextShipDeviceCrosshair",false)
	--wCanonTarget:SetBackgroundBlendEffect( BLEND_EFFECT_ALPHABLND )
	local c_a = get_PS("CannonAim")
	if c_a == "system" then
		w:SetBackgroundBlendEffect( BLEND_EFFECT_ALPHABLND )
		w:SetBackgroundColor( {r = 1, g = 0.0, b = 0.0, a = 1} )
		wtSize(w, 150, 150)
	elseif c_a == "OrkAura01Glow" then
		w:SetBackgroundTexture(common.GetAddonRelatedTexture("OrkAura01Glow"))
		w:SetBackgroundColor( {r = 1, g = 0.3, b = 0.2, a = 0.6} )
		wtSize(w, 150, 150)
	elseif c_a == "CannonAim" then
		w:SetBackgroundTexture(common.GetAddonRelatedTexture("CannonAim"))
		w:SetBackgroundColor( {r = 1, g = 0.1, b = 0.1, a = 1} )
		wtSize(w, 250, 250)
	elseif c_a == "CannonAim2" then
		w:SetBackgroundTexture(common.GetAddonRelatedTexture("CannonAim2"))
		w:SetBackgroundColor( {r = 1, g = 0.3, b = 0.1, a = 0.7} )
		wtSize(w, 150, 150)
	elseif c_a == "sysCannonAim2" then
		local ww = WCD( dsc.PanelEmpty, nil, w, { alignX = 3, alignY = 3}, true )
		ww:SetBackgroundTexture(common.GetAddonRelatedTexture("CannonAim2"))
		ww:SetBackgroundColor( {r = 1, g = 0.3, b = 0.1, a = 0.7} )
		wtSize(w, 150, 150)
	end
	--w = WCD( dsc.PanelEmpty, nil, nil, { alignX = 2, alignY = 2, sizeX = 40, sizeY = 40}, true )
	--w:SetBackgroundTexture(common.GetAddonRelatedTexture("CannonAim2"))


end

