local wts, uts, onEvent, onReact = {}, {}, {}, {}
local priorMob = 50
local SHIELDS_ANGLE = { [SHIP_SIDE_FRONT] = 0, [SHIP_SIDE_REAR] = 3.1416, [SHIP_SIDE_LEFT] = 3.1416/2, [SHIP_SIDE_RIGHT] = -3.1416/2 }

local TextFormat1 = ToWS("<html alignx='center' fontsize='14'><r name='value'/></html>")
local TextFormat2 = ToWS("<html alignx='center' fontsize='14'><r name='value'/></html>")
local TextFormat0 = ToWS("<html alignx='center' fontsize='14' outline='1'><tip_golden><r name='value'/></tip_golden></html>")

local clrRed = {r = 1; g = 0; b = 0; a = 1}
local clrGreen = {r = 0; g = 1; b = 0; a = 1}

local ShipPlatePlaceX, ShipPlatePlaceY


local function sm_Pos( relatX, relatY, dRad )
	local sign = 1
	if math.abs(relatX/relatY) > math.abs(ShipPlatePlaceX/ShipPlatePlaceY) then
		if relatX < 0 then sign = -1 end
		return dRad * sign*(ShipPlatePlaceX-0), dRad * (ShipPlatePlaceY+30) * relatY
	else
		if relatY < 0 then sign = -1 end
		return dRad * (ShipPlatePlaceX+70) * relatX, dRad * sign*(ShipPlatePlaceY+0)
	end
end

local function calcRadius( dist )
	local rr = dist^get_PS("RadarLg") / get_PS("RadarScale")
	local rMax = get_MapRadius() - 30
	return rr > rMax and rMax or rr
end

local function GetTarget( id, event )
	if not object.IsExist( id ) then return
	elseif astralUnit.GetTarget then return astralUnit.GetTarget( id )
--[[	elseif true then
		return unit.GetTarget( id )
	elseif true then
		return object.GetTarget( id )
]]
	elseif event and uts[id] then
		if not uts[id].targ then
			return getMyShipID()
		else
			return nil
		end
	else
		return 0
	end
end

local function calcPosition( uInfo )
	local shipID = getMyShipID()
	local avatarPos = shipID and object.IsExist( shipID ) and transport.GetPosition( shipID )
	if not avatarPos then return end
	--- .position -    - , , 
	--- .GetPos() -  
	local pos = uInfo.position or object.IsExist( uInfo.id ) and uInfo.GetPos( uInfo.id )
	if not pos then return end

	--exObj( FromWS(uInfo.name), pos )

	local angle = - transport.GetDirection( shipID ) + math.pi

	local dX = pos.posX - avatarPos.posX
	local dY = pos.posY - avatarPos.posY

	local dist = math.sqrt(dX*dX + dY*dY) + 0.01

	local cos = math.cos(angle)
	local sin = math.sin(angle)

	local x = dX * sin + dY * cos
	local y = dX * cos - dY * sin

	local relatX = 1 / dist * x
	local relatY = 1 / dist * y
	if uInfo.GetDir then
		angle = angle + ( uInfo.GetDir( uInfo.id ) - math.pi )
	end

	if pos.posZ then
		uInfo.deltaZ = pos.posZ - avatarPos.posZ
	end

	uInfo.dist = dist
	return dist, relatX, relatY, angle

end

local function getDistNum( dist )
	--       
	local d = math.ceil ( dist / 20 ) * 20
	---    
	for i, v in { 250, 450, 600, 750, 800, 1150, 1300 } do
		if math.ceil ( dist / 5 - 5 ) * 5 == v then d = v break end
	end
	return math.ceil(d)
end

local function set_Targ( uInfo, targ )
	if not uInfo then return end

	uInfo.targ = targ -- == getMyShipID()
	uInfo.wHP:GetParent():Show( targ and true or false )
	if not uInfo.image then return end
	if targ == getMyShipID() then
		--uInfo.wt:Enable( true )
		uInfo.wt:SetFade( 1 )
		uInfo.wt:SetPriority( priorMob + 10 )
		wtSetPlace( uInfo.wt, { sizeX = 45, sizeY = 45} )
		uInfo.wHP_sizeX = 45

	elseif targ then
		uInfo.wt:SetFade( 1 )
		uInfo.wt:SetPriority( priorMob + 5 )
		wtSetPlace( uInfo.wt, { sizeX = 35, sizeY = 35} )
		uInfo.wHP_sizeX = 35
	else
		--uInfo.wt:Enable( false )
		uInfo.wt:SetFade( 0.7 )
		uInfo.wt:SetPriority( priorMob - 10 )
		wtSetPlace( uInfo.wt, { sizeX = 30, sizeY = 30} )
		uInfo.wHP_sizeX = 30
	end
end

local function set_HP_unit( uInfo )
	local Percentage
	if astralUnit.GetHealthLevel then Percentage = astralUnit.GetHealthLevel( uInfo.id )
	elseif object.GetHealthInfo then Percentage = object.GetHealthInfo( uInfo.id )
	end
	if not Percentage then return end
	if type(Percentage) == "table" then Percentage = Percentage.valuePercents end
	wtSetPlace( uInfo.wHP, { highPosX=(1-Percentage/100)*uInfo.wHP_sizeX} )
	uInfo.hpp = Percentage
end

local function set_HP_ship( uInfo )
	local Percentage = transport_GetHealth( uInfo.id )
	local clr = getHullColor( Percentage )
	clr.r = clr.r + 0.003*(Percentage-40)
	clr.g = clr.g + 0.003*(Percentage-40)
	clr.b = clr.b + 0.003*(Percentage-40)
	if uInfo.id == getMyShipID() then
		clr.g = clr.g+0.02
	else
	end
	uInfo.wt:SetBackgroundColor( clr )

	if uInfo.wHP then wtSetPlace( uInfo.wHP, { highPosX=(1-Percentage/100)*uInfo.wHP_sizeX} ) end

	uInfo.hpp = Percentage

	local wtEngine, EngineSize = uInfo.wEP, uInfo.wHP_sizeX
	if wtEngine then
		local EN = transport.GetEnergy( uInfo.id )
		local heat = EN.value/EN.limit * 100
		if heat < 50 then
			wtEngine:GetParent():SetBackgroundColor( { r = 0.1, g = 0.3, b = 0.1, a = 1 } )
			clr = { r = 0.2, g = 0.7, b = 0.15, a = 1 }
			wtSetPlace( wtEngine, { alignX = 1, sizeX = EngineSize * heat / 100} )
		elseif heat < 95 then
			wtEngine:GetParent():SetBackgroundColor( { r = 0.1, g = 0.3, b = 0.1, a = 1 } )
			clr = { r = 0.2 + 0.016 * (heat - 50 ), g = 0.7 + 0.005 * ( heat - 50 ), b = 0.15 + 0.002 * (heat - 50 ), a = 1 }
			wtSetPlace( wtEngine, { alignX = 1, sizeX = EngineSize * heat / 100} )
		else
			wtEngine:GetParent():SetBackgroundColor( { r = 0.2 + 0.016 * (95 - 50 ), g = 0.7 + 0.005 * ( 95 - 50 ), b = 0.15 + 0.002 * (95 - 50 ), a = 1 } )
			clr = { r = 1, g = 0.3, b = 0.1, a = 1 }
			wtSetPlace( wtEngine, { alignX = 0, sizeX = ( heat - 100 )/100 * EngineSize * 2} )
		end

		wtEngine:SetBackgroundColor( clr )
		--wtSetPlace( uInfo.wEP, { highPosX=(100 - heat)*uInfo.wHP_sizeX} )

	end

end

local function showShield( uInfo, side )

	local shld = uInfo and transport.GetShieldStrength( uInfo.id, side )
	if not shld then return end
	local proc = shld.value / shld.maxValue * 100
	local w = uInfo.wShld[side]
	if w and proc >= 0 then 
		--LogInfo( w, ":", proc )
		w:SetBackgroundColor( getShieldColor(proc) ) -- { r = 0.95-proc*0.95, g=0.0*proc+0.3, b=0.8*proc+0.0, a=1.0 } )
		w:SetFade( proc > 0.3 and 1 or proc )
	end
end

local function show_deltaZ( uInfo )
	local dZNum = uInfo.deltaZ
	local wTxt = uInfo.w_dZTxt
	if dZNum and wTxt then
		local frmt
		dZNum = math.ceil(dZNum)
		if not uInfo.deltaZt or uInfo.deltaZt ~= dZNum then
			uInfo.deltaZt = dZNum
			if uInfo.dist < 2000 and math.abs(dZNum) > 2 then 
				if false then frmt = ToWS("<html fontname='AllodsSystem' fontsize='18' shadow='1' alignx='center' aligny='meddle'><r name='value'/></html>")
				else frmt = ToWS("<html fontname='AllodsSystem' fontsize='14' shadow='1' alignx='center' aligny='meddle'><r name='value'/></html>")
				end
				wTxt:SetFormat(frmt)
				wTxt:SetVal("value", ToWS(""..dZNum))
				wTxt:Show(true)
			else
				wTxt:Show(false)
			end
		end
	end
end
----------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------

local function del_Obj(id, uInfoIn)
	local uInfo = uInfoIn or uts[id]
	if uInfo then
		--LogToChat("delete:"..FromWS(uts[id].name)) LogInfo("delete:"..FromWS(uts[id].name))
		uInfo.wt:DestroyWidget()

		uts[id] = nil ---      
	end
end

local dRadObj = 1.5
local function show_Obj( uInfo )
	local dist, relatX, relatY, angle = calcPosition( uInfo )
	local w = uInfo.wt
	if dist then
		local rr = 175 + 25
		if IsRadarMode() then rr = calcRadius( dist ) end
		wtSetPlace( w, { posX = rr * relatX, posY = rr * relatY} )
		show_deltaZ( uInfo )
	end
end

local dRadShp = 1.35
local function show_Ship( uInfo )
	local dist, relatX, relatY, angle = calcPosition( uInfo )

	if not dist then return end

	local w = uInfo.wt

	for side, set in SHIELDS_ANGLE do
		uInfo.wShld[side]:Rotate( set + angle )
	end

	if dist > 2 then ---     ?
		local rr
		if IsRadarMode() then
			rr = calcRadius( dist )
			wtSetPlace( w, { posX = rr * relatX, posY = rr * relatY} )
		else
			local X, Y = sm_Pos( relatX, relatY, dRadShp )
			wtSetPlace( w, { posX = X, posY = Y } )
		end
		--wtSetPlace( w, { posX = rr * relatX, posY = rr * relatY} )
		w:Rotate( angle )
		show_deltaZ( uInfo )
	else
		--del_Obj( uInfo.id )
	end
end

local dRadUnt = 1.35
local function show_Unit( uInfo )
	if IsShortMode() then return end
	local dist, relatX, relatY, angle = calcPosition( uInfo )
	if dist then
		local w = uInfo.wt
		local agrr = uInfo.targ == getMyShipID()
		local rr
		local isRdr = IsRadarMode()
		if agrr or isRdr or dist < (get_PS("DistMobs1") or 1300) then
			if isRdr then
				rr = calcRadius( dist )
				wtSetPlace( w, { posX = (rr + ((isRdr or agrr) and 0 or 15)) * relatX, posY = (rr + ((isRdr or agrr) and 0 or 15)) * relatY} )
			else
				local X, Y = sm_Pos( relatX, relatY, dRadUnt*(agrr and 1 or 0.95) )
				wtSetPlace( w, { posX = X, posY = Y } )
			end
			if not w:IsVisible() then w:Show( true ) end
			local wTxt = uInfo.wTxt
			if wTxt then
				local dNum = getDistNum(dist)
				local frmt
				if not uInfo.distNum or uInfo.distNum ~= dNum then
					if dist < 2000 then 
						if agrr then frmt = ToWS("<html fontname='AllodsSystem' fontsize='18' shadow='1' alignx='center' aligny='meddle'><r name='value'/></html>")
						else frmt = ToWS("<html fontname='AllodsSystem' fontsize='14' shadow='1' alignx='center' aligny='meddle'><r name='value'/></html>")
						end
						
						wTxt:SetFormat(frmt)
						wTxt:SetVal("value", ToWS(""..dNum))
						wTxt:Show(true)
						uInfo.distNum = dNum
					else
						wTxt:Show(false)
					end
				end
			end
		else
			if w:IsVisible() then w:Show( false ) end
		end

	else
		--del_Obj( uInfo.id )
	end
end

local function add_Edge( id, angle, hubR )
	local uInfo = uts[id]
	if not uInfo then
		uInfo = { id = id, name = ToWS(L("EDGE")), description = ToWS(L("HUB Edge Point ")..id),
			position = {}, image = common.GetAddonRelatedTexture( "ScoresContainerItemOnline" ) --, "SlotHighlight" ),
			}
		local w = WCD( dsc.PanelER, id.."", Get_Panel(), { sizeX = 20, sizeY = 20, alignX=2, alignY=2}, true )
		w:SetPriority( 0 ) --priorMob - 50)
		if uInfo.image then
			w:SetBackgroundTexture( uInfo.image )
			w:SetBackgroundColor( { a=1, r=0.7, g=0.2, b=0.1 } )
		end
		uInfo.Show = show_Obj
		uInfo.wt = w
		uts[id] = uInfo
	end
	uInfo.position.posX = hubR * math.sin( angle )
	uInfo.position.posY = hubR * math.cos( angle )
	show_Obj( uInfo )
end

local function add_Obj(id)
	local uInfo = astral.GetObjectInfo( id )
	uInfo.Show = show_Obj
	uts[id] = uInfo
	local w = WCD( dsc.PanelER, id.."", Get_Panel(), { sizeX = 30, sizeY = 30, alignX=2, alignY=2}, false )
	w:SetPriority( priorMob + 50)
	if uInfo.image then w:SetBackgroundTexture( uInfo.image ) end
	uInfo.wt = w

	local wTxt = WCD( dsc.Text, nil, w, { alignX = 3, alignY=3, sizeY=15 }, true )
	wTxt:SetEllipsis( false )
	uInfo.w_dZTxt = wTxt

	show_Obj( uInfo )
	w:Enable( uInfo.isEnabled )
	w:Show( true )
end

function SetImageMyShip( id, uInfoIn )
	local uInfo = uInfoIn or uts[id]
	if not uInfo then return end
	local w = uInfo.wt
	local wtRP = Get_RadarPlate()
	wtRP:AddChild( w )
	wtSetPlace( w, { sizeX = 60, sizeY = 60 } )
	w:SetBackgroundColor( { r = 0.1, g=0.5, b=0.2, a=1 } )
end

function add_Ship(id)

	local sizeX = 50

	local plc = { sizeX = sizeX, sizeY = sizeX, alignX=2, alignY=2}
	local w = WCD( dsc.PanelER, id.."", Get_Panel(), plc, false )
	w:SetPriority( priorMob + 40)

	local uInfo = { id = id, type = "SHIP", name = object.GetName( id ), GetPos = transport.GetPosition, GetDir = transport.GetDirection,
		Show = show_Ship, set_Targ = nil, set_HP = set_HP_ship,
		wt = w, image = common.GetAddonRelatedTexture( "ShipSymbol" ), }  --astral.GetObjectInfo( id )
	uts[id] = uInfo

	local wbar = WCD( dsc.BarHP, nil, w, { alignX = 3, alignY=0, sizeY=10 }, true )
	wbar:SetBackgroundColor( {r=.2; g=0.0; b=0, a=1 } )
	uInfo.wHP = W("dscBar", wbar )
	uInfo.wHP:SetBackgroundColor( {r=.9; g=0.2; b=0, a=1 } )
	uInfo.wHP:Show( true )
	uInfo.wHP_sizeX = sizeX

	local wbar = WCD( dsc.BarHP, nil, w, { alignX = 3, alignY=1, sizeY=7 }, true )
	wbar:SetBackgroundColor( {r=0.0; g=0.2; b=0.1, a=1 } )
	uInfo.wEP = W("dscBar", wbar )
	uInfo.wEP:SetBackgroundColor( {r=.9; g=0.2; b=0, a=1 } )
	uInfo.wEP:Show( true )
	uInfo.wEP_sizeX = sizeX

	if uInfo.image then w:SetBackgroundTexture( uInfo.image ) end

	local wCh
	uInfo.wShld = {}
	for side, angle in SHIELDS_ANGLE do
		wCh = WCD( dsc.PanelEmpty, "shldSide_"..side, w, { alignX = 3, alignY = 3 }, true )
		wCh:SetBackgroundTexture( common.GetAddonRelatedTexture( "ShipPlateShieldArc" ) )
		uInfo.wShld[side] = wCh
		showShield( uInfo, side )
	end

	local wTxt = WCD( dsc.Text, nil, w, { alignX = 3, alignY=3, sizeY=15 }, true )
	wTxt:SetEllipsis( false )
	uInfo.w_dZTxt = wTxt

	uInfo.set_HP( uInfo )
	uInfo.Show( uInfo )

	w:Show( true )
	if id == getMyShipID() then
		SetImageMyShip( id, uInfo )
	end

end

local imageTemp
local function add_Unit(id)
	local uInfo = { id = id, type = "UNIT", name = object.GetName( id ), GetPos = object.GetPos,
		Show = show_Unit, set_Targ = set_Targ, set_HP = set_HP_unit,
		image = astralUnit.GetImage( id ), level = astralUnit.GetLevel( id ) }
	-- position = object.GetPos( id ),
	uts[id] = uInfo

	local sizeX = 30
	local w = WCD( dsc.PanelER, id.."", Get_Panel(), { sizeX = sizeX, sizeY = sizeX, alignX=2, alignY=2}, false )
	w:SetPriority( priorMob )
	uInfo.wt = w

	local wbar = WCD( dsc.BarHP, nil, w, { alignX = 3, alignY=0, sizeY=8 }, true )
	wbar:SetBackgroundColor( {r=.2; g=0.0; b=0, a=1 } )
	uInfo.wHP = W("dscBar", wbar )
	uInfo.wHP:SetBackgroundColor( {r=.9; g=0.2; b=0, a=1 } )
	uInfo.wHP:Show( true )
	uInfo.wHP_sizeX = sizeX

	if uInfo.image then
		--if not imageTemp then imageTemp = uInfo.image end
		w:SetBackgroundTexture( uInfo.image )
	else
		w:SetBackgroundTexture( common.GetAddonRelatedTexture("Monster") )
		--w:SetBackgroundColor( {r=.0; g=0.6; b=0.7, a=1 } )
	end
	local wTxt = WCD( dsc.Text, nil, w, { alignX = 3, alignY=1, sizeY=15 }, true )
	wTxt:SetEllipsis( false )
	uInfo.wTxt = wTxt

	uInfo.set_Targ( uInfo, GetTarget( id ) )
	uInfo.set_HP( uInfo )
	uInfo.Show( uInfo )
	--w:Show( true )
end

function repaintPos( uInfo, trPos1)

	local ShipID = getMyShipID()
	local trPos = trPos1 or ShipID and object.IsExist( ShipID ) and transport.GetPosition( getMyShipID() )
	if uInfo then
		--if uInfo.set_Targ then uInfo.set_Targ( uInfo, GetTarget( id ) ) end
		--if uInfo.set_HP then uInfo.set_HP( uInfo ) end
		uInfo.Show( uInfo, trPos )
	else
		for _, info in uts do
			if info then repaintPos( info, trPos ) end
		end
		repaintScale()
	end
end

--[[
onEvent.EVENT_EFFECT_FINISHED = function( pars )
	local wID = pars.wtOwner:GetInstanceId()
	local obj = wts[ wID ]
	if  obj then
		if pars.effectType ~= ET_FADE then return end
		wts[pars.wtOwner:GetInstanceId()] = nil
		obj:DestroyWidget()
	end
end
]]

local sec1, sec2 = 45, 55
onEvent["EVENT_SECOND_TIMER"] = function ( pars )
	if not getMyShipID() then return end
		--[[local markers = cartographer.GetMapMarkers( zonesMapId )
		for i, markerId in markers do
			local markerInfo = cartographer.GetMarkerInfo( markerId )
			local markerObjects = cartographer.GetMapMarkerObjects( zonesMapId, markerId )
		end
		]]
	for id, uInfo in uts do
		if uInfo.set_Targ then uInfo.set_Targ( uInfo, GetTarget( id ) ) end
		if uInfo.set_HP then uInfo.set_HP( uInfo ) end
		if uInfo.hpp and uInfo.hpp == 0 and uInfo.type and uInfo.type == "UNIT" then
			---     0%    -   
			del_Obj( id, uInfo ) 
		end
	end

end

onEvent["EVENT_ASTRAL_HUB_CHANGED"] = function ( pars )
	--         
	if not astral.GetCurrentSector() then return end
	local re = tonumber( get_PS("RadarEdge") )
	if re and re > 0 then
		local hubR = astral.GetHubRadius()
		--LogToChat(" hubR = " ..hubR )
		local an
		for i=0, re - 1 do
			an = 2*math.pi / re * i
			add_Edge( i, an, hubR )
		end
	end
end

onEvent["EVENT_TRANSPORT_POS_CHANGED"] = function ( pars )
	if not getMyShipID() then return end
	local id = pars.id
	if id == getMyShipID() then
		---  
		repaintPos()
	elseif uts[id] then
		--  
		repaintPos(uts[id])
	end
end
onEvent["EVENT_TRANSPORT_DIRECTION_CHANGED"] = function ( pars )
	local id = pars.id
	if id == getMyShipID() then
		repaintPos()
	elseif uts[id] then
		--  
		repaintPos(uts[id])
	end
end

--[[onEvent["EVENT_TRANSPORT_HEALTH_CHANGED"] = function ( pars )
	uts[id].hpp = transport_GetHealth( pars.id )
end
]]
onEvent["EVENT_ASTRAL_OBJECT_DESPAWNED"] = function ( pars )
	del_Obj(pars.objectId)
end
onEvent["EVENT_ASTRAL_OBJECT_SPAWNED"] = function ( pars )
	add_Obj(pars.objectId)
end
onEvent["EVENT_TRANSPORT_SPAWNED"] = function ( pars )
	--         !
	-- exObj( "par", pars )	LogInfo( getMyShipID() )
	if not getMyShipID() then return end
	add_Ship(pars.id)
end
onEvent["EVENT_TRANSPORT_DESPAWNED"] = function ( pars )
	del_Obj(pars.id)
end

onEvent["EVENT_ASTRAL_UNIT_SPAWNED"] = function ( pars )
	if getMyShipID() then add_Unit(pars.unitId) end
end
onEvent["EVENT_ASTRAL_UNIT_DESPAWNED"] = function ( pars )
	del_Obj(pars.unitId)
end
onEvent["EVENT_ASTRAL_UNIT_HEALTH_PERCENTAGE_CHANGED"] = function ( pars )
	--     ((LogToChat("HHHC")
	set_HP( uts[pars.unitId])
end
onEvent["EVENT_ASTRAL_UNIT_POS_CHANGED"] = function ( pars )
	repaintPos(uts[pars.unitId])
end
onEvent["-EVENT_AVATAR_USED_OBJECT_CHANGED"] = function ( pars )
end
onEvent["EVENT_ASTRAL_UNIT_TARGET_CHANGED"] = function ( pars )
	--LogToChat("EVENT_ASTRAL_UNIT_TARGET_CHANGED")
	local id = pars.id
	local uInfo = uts[id]
	if uInfo then set_Targ( uInfo, GetTarget( id, true ) ) end
end

local function unitPlayerSpawned( id )
	if not unit.IsPlayer ( id ) then return end
	local shipID = unit.GetTransport( id )
	if not shipID or shipID == getMyShipID() then return end

	LogToChat(object.GetName( id ))
end

onEvent["EVENT_UNITS_CHANGED"] = function ( pars )
	if not getMyShipID() then return end
	for _, id in pars.spawned do
		--onSpawnedUnit( { unitId = id } )
		unitPlayerSpawned( id )
	end
	for _, id in pars.despawned do
		--onDespawnedPlayer( { unitId = id } )
	end
end

--[[
onEvent["EVENT_ASTRAL_HUB_CHANGED"] = function ( pars )
	for id, info in uts do
		del_Obj(id)
	end
	for _, id in astral.GetObjects() do
		add_Obj(id)
	end
end
]]

--[[
onEvent["EVENT_SHIELD_STRENGTH_CHANGED"] = function ( pars )
	--       !     
	LogToChat("EVENT_SHIELD_STRENGTH_CHANGED")
	--LogInfo( object.GetName( pars.id ) )
	exObj("EVENT_SHIELD_STRENGTH_CHANGED", pars)
	local shipId = device.GetTransport( pars.id )
	local side = device.GetShipSlotInfo( pars.id )
	LogInfo("ship: ", object.GetName( shipId ) )
	if shipId then showShield( uts[shipId], side ) end
end
]]

onEvent["EVENT_TRANSPORT_SHIELD_CHANGED"] = function ( pars )
	--LogToChat("EVENT_TRANSPORT_SHIELD_CHANGED")
	--exObj("EVENT_TRANSPORT_SHIELD_CHANGED", pars)
	--LogInfo("ship: ", object.GetName( pars.id ) )
	showShield( uts[pars.id], pars.side )
end

-------------- REACTIONS --------------
---------------------------------------
onReact[ "panel_over" ] = function( reaction )
	if not getMyShipID() then return end

	local id = tonumber ( reaction.widget:GetName() )
	--LogToChat( " id:"..id.." name:"..reaction.widget:GetName() )
	local uInfo = id and uts[id]
	if not uInfo then return end
	show_tip( { obj = uInfo }, reaction.active, reaction.widget )
end
onReact[ "mouse_double_click" ] = function( reaction )
	LogToChat("mouse_double_click")

end
-----------------------------------------
---------------- INIT -------------------
-----------------------------------------

function wtInit()
	--[[
	wtMainPanel = WCD( dsc.Panel, "MainPanel", nil, _PS.ShipPlatePlace, false )
	wtCCB = WCD( dsc.ButtonCornerCross, "ButtonCornerCross", wtMainPanel, {}, true )
	wtCCB:SetPriority( 500 )

	DnD:Init(wtCCB, wtMainPanel, true )

	wtShip = WCD( dsc.Menu, "Ship", wtMainPanel, { alignX=3, alignY=3, highPosY = 20}, true )
	wtShip:SetBackgroundColor( { r = 0, g = 0, b = 0, a=0.5 } )

	-- WCD(descr, name, parent, place, show )
	local w, wp
	]]
end

------------- init functions -------------
function ShortMap_ShowAll()
	for i, id in astral.GetObjects() do
		add_Obj( id )
	end
	for i, id in avatar.GetTransportList() do
		--if getMyShipID() and id ~= getMyShipID() then add_Ship(id) end
		add_Ship( id ) 
	end
	for i, id in astral.GetUnits() do
		add_Unit( id )
	end
	for i, id in avatar.GetUnitList() do
		unitPlayerSpawned( id )
	end

	onEvent.EVENT_ASTRAL_HUB_CHANGED()

end

function ShortMap_Init( myShipID )

	wtInit()
	RegisterEventHandlers( onEvent )
	RegisterReactionHandlers( onReact )

	local p = get_PS("ShipPlatePlace")
	ShipPlatePlaceX = p.sizeX/2
	ShipPlatePlaceY = p.sizeY/2

end
